/* Copyright 2021 Riscure */

#include <stdarg.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/mman.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdbool.h>
#include <assert.h>

#include "Votaes.h"
#include "verilated.h"
#include "verilated_vcd_c.h"
#include "../bitlified.h"

#define COMMAND_VERSION 0xABCD0000
#define COMMAND_GLITCH 0xABCD0001
#define COMMAND_EXIT 0xABCD0002

#define UART0_BASE_ADDRESS          0xA0000000
#define UART0_STATUS                0x00000000
#define UART0_TX_DATA               0x00000004
#define UART0_RX_DATA               0x00000008

#define TEST_STATUS 0xB0000000

#define ANSI_COLOR_RED     "\x1b[31m"
#define ANSI_COLOR_GREEN   "\x1b[32m"
#define ANSI_COLOR_YELLOW  "\x1b[33m"
#define ANSI_COLOR_BLUE    "\x1b[34m"
#define ANSI_COLOR_MAGENTA "\x1b[35m"
#define ANSI_COLOR_CYAN    "\x1b[36m"
#define ANSI_COLOR_RESET   "\x1b[0m"

#define MSG_TEST_STATUS 0x01
#define MSG_PID 0x03
#define MSG_NUM_MACHINES 0x04
#define MSG_STATUS 0x05
#define MSG_CMD 0x06
#define MSG_GLITCHBUF 0x07
#define MSG_ARGS 0x08


#define TEST_NO_FAULT (0 << 6)
#define TEST_EXPLOITABLE (1 << 6)
#define TEST_UNEXPLOITABLE (2 << 6)
#define TEST_UNKNOWN_FAULT (3 << 6)

#define AES_BYTES 16
#define HD_CUTOFF 4+1

#include <errno.h>
#include <string.h>

#define clean_errno() (errno == 0 ? "None" : strerror(errno))
#define log_error(M, ...) fprintf(stderr, "[%d][ERROR] (%s:%d: errno: %s) " M "\n", getpid(), __FILE__, __LINE__, clean_errno(), ##__VA_ARGS__)
#define assertf(A, M, ...) if(!(A)) { log_error(M, ##__VA_ARGS__); assert(A); }
	/* Encrypting 00000000000000000000000000000000 with key 00000000000000000000000000000000 */
/*    uint8_t aes_states[][AES_BYTES] = 
{{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00}, 
{0x63, 0x63, 0x63, 0x63, 0x63, 0x63, 0x63, 0x63, 0x63, 0x63, 0x63, 0x63, 0x63, 0x63, 0x63, 0x63}, 
{0x63, 0x63, 0x63, 0x63, 0x63, 0x63, 0x63, 0x63, 0x63, 0x63, 0x63, 0x63, 0x63, 0x63, 0x63, 0x63}, 
{0x63, 0x63, 0x63, 0x63, 0x63, 0x63, 0x63, 0x63, 0x63, 0x63, 0x63, 0x63, 0x63, 0x63, 0x63, 0x63}, 
{0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00}, 
{0x7c, 0x63, 0x63, 0x63, 0x7c, 0x63, 0x63, 0x63, 0x7c, 0x63, 0x63, 0x63, 0x7c, 0x63, 0x63, 0x63}, 
{0x7c, 0x63, 0x63, 0x63, 0x7c, 0x63, 0x63, 0x63, 0x7c, 0x63, 0x63, 0x63, 0x7c, 0x63, 0x63, 0x63}, 
{0x5d, 0x7c, 0x7c, 0x42, 0x5d, 0x7c, 0x7c, 0x42, 0x5d, 0x7c, 0x7c, 0x42, 0x5d, 0x7c, 0x7c, 0x42}, 
{0xc6, 0xe4, 0xe4, 0x8b, 0xa4, 0x87, 0x87, 0xe8, 0xc6, 0xe4, 0xe4, 0x8b, 0xa4, 0x87, 0x87, 0xe8}, 
{0xb4, 0x69, 0x69, 0x3d, 0x49, 0x17, 0x17, 0x9b, 0xb4, 0x69, 0x69, 0x3d, 0x49, 0x17, 0x17, 0x9b}, 
{0xb4, 0x17, 0x69, 0x9b, 0x49, 0x69, 0x17, 0x3d, 0xb4, 0x17, 0x69, 0x9b, 0x49, 0x69, 0x17, 0x3d}, 
{0xb8, 0xba, 0xc7, 0x94, 0x03, 0x9f, 0x49, 0xdf, 0xb8, 0xba, 0xc7, 0x94, 0x03, 0x9f, 0x49, 0xdf}, 
{0x28, 0x2d, 0xf3, 0xc4, 0x6a, 0xf3, 0x86, 0x25, 0x4a, 0x4e, 0x90, 0xa7, 0x08, 0x90, 0xe5, 0x46}, 
{0x34, 0xd8, 0x0d, 0x1c, 0x02, 0x0d, 0x44, 0x3f, 0xd6, 0x2f, 0x60, 0x5c, 0x30, 0x60, 0xd9, 0x5a}, 
{0x34, 0x0d, 0x60, 0x5a, 0x02, 0x2f, 0xd9, 0x1c, 0xd6, 0x60, 0x0d, 0x3f, 0x30, 0xd8, 0x44, 0x5c}, 
{0x45, 0xd4, 0x17, 0x85, 0xb0, 0x30, 0xa0, 0xc8, 0x25, 0x3e, 0xed, 0x72, 0x0b, 0x0b, 0x84, 0x74}, 
{0xab, 0xd2, 0xcd, 0xfe, 0x37, 0x5a, 0xb5, 0x49, 0x50, 0xa0, 0xaf, 0xc0, 0x75, 0x9a, 0x6a, 0x5f}, 
{0x62, 0xb5, 0xbd, 0xbb, 0x9a, 0xbe, 0xd5, 0x3b, 0x53, 0xe0, 0x79, 0xba, 0x9d, 0xb8, 0x02, 0xcf}, 
{0x62, 0xbe, 0x79, 0xcf, 0x9a, 0xe0, 0x02, 0xbb, 0x53, 0xb8, 0xbd, 0x3b, 0x9d, 0xb5, 0xd5, 0xba}, 
{0xab, 0x41, 0x64, 0xe4, 0xad, 0xfc, 0xa8, 0x3a, 0xf3, 0xdf, 0xc7, 0x86, 0x8a, 0x32, 0x4c, 0xb3}, 
{0xd4, 0x6f, 0x4f, 0x6c, 0x55, 0xb8, 0x96, 0x33, 0x7e, 0x05, 0xbb, 0x3d, 0x79, 0x79, 0xde, 0x23}, 
{0x48, 0xa8, 0x84, 0x50, 0xfc, 0x6c, 0x90, 0xc3, 0xf3, 0x6b, 0xea, 0x27, 0xb6, 0xb6, 0x1d, 0x26}, 
{0x48, 0x6c, 0xea, 0x26, 0xfc, 0x6b, 0x1d, 0x50, 0xf3, 0xb6, 0x84, 0xc3, 0xb6, 0xa8, 0x90, 0x27}, 
{0xe8, 0x93, 0x81, 0x12, 0x13, 0x5d, 0x5d, 0xc9, 0x7b, 0xd0, 0x08, 0xa1, 0x23, 0x71, 0x4c, 0xb7}, 
{0x04, 0xf2, 0xca, 0x97, 0x07, 0x78, 0x28, 0x45, 0xe2, 0x2f, 0x01, 0x96, 0x49, 0xc5, 0xd7, 0x10}, 
{0xf2, 0x89, 0x74, 0x88, 0xc5, 0xbc, 0x34, 0x6e, 0x98, 0x15, 0x7c, 0x90, 0x3b, 0xa6, 0x0e, 0xca}, 
{0xf2, 0xbc, 0x7c, 0xca, 0xc5, 0x15, 0x0e, 0x88, 0x98, 0xa6, 0x74, 0x6e, 0x3b, 0x89, 0x34, 0x90}, 
{0x96, 0xdf, 0xf3, 0x42, 0x28, 0x75, 0x4f, 0x44, 0xc0, 0x3d, 0x64, 0xbd, 0x52, 0xfe, 0x71, 0xcb}, 
{0xb7, 0xaa, 0xe4, 0xc5, 0x1d, 0x25, 0x2d, 0x4f, 0x6c, 0x92, 0x0f, 0x81, 0x94, 0xe5, 0x81, 0x50}, 
{0xa9, 0xac, 0x69, 0xa6, 0xa4, 0x3f, 0xd8, 0x84, 0x50, 0x4f, 0x76, 0x0c, 0x22, 0xd9, 0x0c, 0x53}, 
{0xa9, 0x3f, 0x76, 0x53, 0xa4, 0x4f, 0x0c, 0xa6, 0x50, 0xd9, 0x69, 0x84, 0x22, 0xac, 0xd8, 0x0c}, 
{0x2d, 0x1e, 0x8f, 0x0f, 0x28, 0x88, 0x02, 0xe3, 0x3d, 0xc6, 0xcc, 0x53, 0x7f, 0x1e, 0x31, 0x0a}, 
{0x23, 0xe7, 0x8c, 0x3c, 0x13, 0x21, 0x63, 0xdb, 0xaa, 0xc0, 0xc6, 0x57, 0x2e, 0x03, 0xcb, 0x95}, 
{0x26, 0x94, 0x64, 0xeb, 0x7d, 0xfd, 0xfb, 0xb9, 0xac, 0xba, 0xb4, 0x5b, 0x31, 0x7b, 0x1f, 0x2a}, 
{0x26, 0xfd, 0xb4, 0x2a, 0x7d, 0xba, 0x1f, 0xeb, 0xac, 0x7b, 0x64, 0xb9, 0x31, 0x94, 0xfb, 0x5b}, 
{0xce, 0x2a, 0xd6, 0x77, 0xdb, 0xd8, 0xdf, 0xef, 0x13, 0x4f, 0xcf, 0x99, 0x65, 0x4f, 0xa5, 0x8a}, 
{0x7f, 0xfe, 0x0e, 0x95, 0x51, 0xa5, 0x66, 0x35, 0x0e, 0x34, 0x7c, 0x47, 0x29, 0x29, 0xec, 0xcb}, 
{0xd2, 0xbb, 0xab, 0x2a, 0xd1, 0x06, 0x33, 0x96, 0xab, 0x18, 0x10, 0xa0, 0xa5, 0xa5, 0xce, 0x1f}, 
{0xd2, 0x06, 0x10, 0x1f, 0xd1, 0x18, 0xce, 0x2a, 0xab, 0xa5, 0xab, 0x96, 0xa5, 0xbb, 0x33, 0xa0}}; 
	uint8_t aes_correct[AES_BYTES] = {0x66, 0xe9, 0x4b, 0xd4, 0xef, 0x8a, 0x2c, 0x3b, 0x88, 0x4c, 0xfa, 0x59, 0xca, 0x34, 0x2b, 0x2e}; */

/* Encrypting abcdef0990fedcbabcdef097790fedcb with key 01234567765432101234567887654321 */
	uint8_t aes_key[AES_BYTES] = {0x01, 0x23, 0x45, 0x67, 0x76, 0x54, 0x32, 0x10, 0x12, 0x34, 0x56, 0x78, 0x87, 0x65, 0x43, 0x21};
	uint8_t aes_states[][AES_BYTES] = {
{0xab, 0xcd, 0xef, 0x09, 0x90, 0xfe, 0xdc, 0xba, 0xbc, 0xde, 0xf0, 0x97, 0x79, 0x0f, 0xed, 0xcb}, // input : 0
{0x01, 0x23, 0x45, 0x67, 0x76, 0x54, 0x32, 0x10, 0x12, 0x34, 0x56, 0x78, 0x87, 0x65, 0x43, 0x21}, // rk    : 1
{0xaa, 0xee, 0xaa, 0x6e, 0xe6, 0xaa, 0xee, 0xaa, 0xae, 0xea, 0xa6, 0xef, 0xfe, 0x6a, 0xae, 0xea}, // addkey: 1
{0xac, 0x28, 0xac, 0x9f, 0x8e, 0xac, 0x28, 0xac, 0xe4, 0x87, 0x24, 0xdf, 0xbb, 0x02, 0xe4, 0x87}, // sub   : 1
{0xac, 0xac, 0x24, 0x87, 0x8e, 0x87, 0xe4, 0x9f, 0xe4, 0x02, 0xac, 0xac, 0xbb, 0x28, 0x28, 0xdf}, // shift : 1
{0x0f, 0x04, 0xda, 0x72, 0xee, 0x33, 0x60, 0xcf, 0xd5, 0xa3, 0x4a, 0xda, 0xe2, 0x4c, 0xb9, 0x73}, // mix   : 1
{0x4d, 0x39, 0xb8, 0x70, 0x3b, 0x6d, 0x8a, 0x60, 0x29, 0x59, 0xdc, 0x18, 0xae, 0x3c, 0x9f, 0x39}, // rk    : 2
{0x42, 0x3d, 0x62, 0x02, 0xd5, 0x5e, 0xea, 0xaf, 0xfc, 0xfa, 0x96, 0xc2, 0x4c, 0x70, 0x26, 0x4a}, // addkey: 2
{0x2c, 0x27, 0xaa, 0x77, 0x03, 0x58, 0x87, 0x79, 0xb0, 0x2d, 0x90, 0x25, 0x29, 0x51, 0xf7, 0xd6}, // sub   : 2
{0x2c, 0x58, 0x90, 0xd6, 0x03, 0x2d, 0xf7, 0x77, 0xb0, 0x51, 0xaa, 0x79, 0x29, 0x27, 0x87, 0x25}, // shift : 2
{0xf6, 0xe1, 0x2e, 0x0b, 0xf1, 0x2c, 0x42, 0x31, 0x5b, 0x8e, 0x25, 0xc2, 0x99, 0xd0, 0x74, 0x91}, // mix   : 2
{0xa4, 0xe2, 0xaa, 0x94, 0x9f, 0x8f, 0x20, 0xf4, 0xb6, 0xd6, 0xfc, 0xec, 0x18, 0xea, 0x63, 0xd5}, // rk    : 3
{0x52, 0x03, 0x84, 0x9f, 0x6e, 0xa3, 0x62, 0xc5, 0xed, 0x58, 0xd9, 0x2e, 0x81, 0x3a, 0x17, 0x44}, // addkey: 3
{0x00, 0x7b, 0x5f, 0xdb, 0x9f, 0x0a, 0xaa, 0xa6, 0x55, 0x6a, 0x35, 0x31, 0x0c, 0x80, 0xf0, 0x1b}, // sub   : 3
{0x00, 0x0a, 0x35, 0x1b, 0x9f, 0x6a, 0xf0, 0xdb, 0x55, 0x80, 0x5f, 0xa6, 0x0c, 0x7b, 0xaa, 0x31}, // shift : 3
{0x30, 0x50, 0x4d, 0x09, 0xb0, 0x9b, 0x78, 0x8d, 0xc8, 0x09, 0x9a, 0x77, 0x0e, 0x2e, 0x6b, 0xa7}, // mix   : 3
{0x27, 0x19, 0xa9, 0x39, 0xb8, 0x96, 0x89, 0xcd, 0x0e, 0x40, 0x75, 0x21, 0x16, 0xaa, 0x16, 0xf4}, // rk    : 4
{0x17, 0x49, 0xe4, 0x30, 0x08, 0x0d, 0xf1, 0x40, 0xc6, 0x49, 0xef, 0x56, 0x18, 0x84, 0x7d, 0x53}, // addkey: 4
{0xf0, 0x3b, 0x69, 0x04, 0x30, 0xd7, 0xa1, 0x09, 0xb4, 0x3b, 0xdf, 0xb1, 0xad, 0x5f, 0xff, 0xed}, // sub   : 4
{0xf0, 0xd7, 0xdf, 0xed, 0x30, 0x3b, 0xff, 0x04, 0xb4, 0x5f, 0x69, 0x09, 0xad, 0x3b, 0xa1, 0xb1}, // shift : 4
{0xab, 0xd2, 0xae, 0xc2, 0xd6, 0x58, 0xe2, 0x9c, 0xf2, 0xb8, 0x22, 0xe3, 0x1c, 0x92, 0x07, 0x0f}, // mix   : 4
{0x83, 0x5e, 0x16, 0x7e, 0x3b, 0xc8, 0x9f, 0xb3, 0x35, 0x88, 0xea, 0x92, 0x23, 0x22, 0xfc, 0x66}, // rk    : 5
{0x28, 0x8c, 0xb8, 0xbc, 0xed, 0x90, 0x7d, 0x2f, 0xc7, 0x30, 0xc8, 0x71, 0x3f, 0xb0, 0xfb, 0x69}, // addkey: 5
{0x34, 0x64, 0x6c, 0x65, 0x55, 0x60, 0xff, 0x15, 0xc6, 0x04, 0xe8, 0xa3, 0x75, 0xe7, 0x0f, 0xf9}, // sub   : 5
{0x34, 0x60, 0xe8, 0xf9, 0x55, 0x04, 0x0f, 0x65, 0xc6, 0xe7, 0x6c, 0x15, 0x75, 0x64, 0xff, 0xa3}, // shift : 5
{0xd9, 0x2e, 0x8f, 0x3d, 0xcc, 0x29, 0xe0, 0x3e, 0xdc, 0xb2, 0xc6, 0xf0, 0x1a, 0x04, 0x0a, 0x59}, // mix   : 5
{0x00, 0xee, 0x25, 0x58, 0x3b, 0x26, 0xba, 0xeb, 0x0e, 0xae, 0x50, 0x79, 0x2d, 0x8c, 0xac, 0x1f}, // rk    : 6
{0xd9, 0xc0, 0xaa, 0x65, 0xf7, 0x0f, 0x5a, 0xd5, 0xd2, 0x1c, 0x96, 0x89, 0x37, 0x88, 0xa6, 0x46}, // addkey: 6
{0x35, 0xba, 0xac, 0x4d, 0x68, 0x76, 0xbe, 0x03, 0xb5, 0x9c, 0x90, 0xa7, 0x9a, 0xc4, 0x24, 0x5a}, // sub   : 6
{0x35, 0x76, 0x90, 0x5a, 0x68, 0x9c, 0x24, 0x4d, 0xb5, 0xc4, 0xac, 0x03, 0x9a, 0xba, 0xbe, 0xa7}, // shift : 6
{0x3a, 0x28, 0x96, 0x0d, 0x06, 0x6a, 0x6b, 0x9a, 0x89, 0xca, 0x37, 0xaa, 0xe3, 0x8b, 0xb5, 0xe4}, // mix   : 6
{0x44, 0x7f, 0xe5, 0x80, 0x7f, 0x59, 0x5f, 0x6b, 0x71, 0xf7, 0x0f, 0x12, 0x5c, 0x7b, 0xa3, 0x0d}, // rk    : 7
{0x7e, 0x57, 0x73, 0x8d, 0x79, 0x33, 0x34, 0xf1, 0xf8, 0x3d, 0x38, 0xb8, 0xbf, 0xf0, 0x16, 0xe9}, // addkey: 7
{0xf3, 0x5b, 0x8f, 0x5d, 0xb6, 0xc3, 0x18, 0xa1, 0x41, 0x27, 0x07, 0x6c, 0x08, 0x8c, 0x47, 0x1e}, // sub   : 7
{0xf3, 0xc3, 0x07, 0x1e, 0xb6, 0x27, 0x47, 0x5d, 0x41, 0x8c, 0x8f, 0xa1, 0x08, 0x5b, 0x18, 0x6c}, // shift : 7
{0xba, 0x79, 0x1c, 0xf6, 0x04, 0x6c, 0xf8, 0x1b, 0x23, 0x69, 0x30, 0x99, 0x89, 0xfa, 0xd7, 0x83}, // mix   : 7
{0x25, 0x75, 0x32, 0xca, 0x5a, 0x2c, 0x6d, 0xa1, 0x2b, 0xdb, 0x62, 0xb3, 0x77, 0xa0, 0xc1, 0xbe}, // rk    : 8
{0x9f, 0x0c, 0x2e, 0x3c, 0x5e, 0x40, 0x95, 0xba, 0x08, 0xb2, 0x52, 0x2a, 0xfe, 0x5a, 0x16, 0x3d}, // addkey: 8
{0xdb, 0xfe, 0x31, 0xeb, 0x58, 0x09, 0x2a, 0xf4, 0x30, 0x37, 0x00, 0xe5, 0xbb, 0xbe, 0x47, 0x27}, // sub   : 8
{0xdb, 0x09, 0x00, 0x27, 0x58, 0x37, 0x47, 0xeb, 0x30, 0xbe, 0x31, 0xf4, 0xbb, 0xfe, 0x2a, 0xe5}, // shift : 8
{0x91, 0xee, 0xbb, 0x31, 0x45, 0x14, 0xc7, 0x55, 0x7c, 0xf0, 0xeb, 0x2c, 0xbb, 0xc7, 0x25, 0xd3}, // mix   : 8
{0x45, 0x0d, 0x9c, 0x3f, 0x1f, 0x21, 0xf1, 0x9e, 0x34, 0xfa, 0x93, 0x2d, 0x43, 0x5a, 0x52, 0x93}, // rk    : 9
{0xd4, 0xe3, 0x27, 0x0e, 0x5a, 0x35, 0x36, 0xcb, 0x48, 0x0a, 0x78, 0x01, 0xf8, 0x9d, 0x77, 0x40}, // addkey: 9
{0x48, 0x11, 0xcc, 0xab, 0xbe, 0x96, 0x05, 0x1f, 0x52, 0x67, 0xbc, 0x7c, 0x41, 0x5e, 0xf5, 0x09}, // sub   : 9
{0x48, 0x96, 0xbc, 0x09, 0xbe, 0x67, 0xf5, 0xab, 0x52, 0x5e, 0xcc, 0x1f, 0x41, 0x11, 0x05, 0x7c}, // shift : 9
{0x84, 0xa9, 0xa6, 0xe0, 0x90, 0xdf, 0xce, 0x06, 0x95, 0xbe, 0xae, 0x5a, 0xc8, 0x10, 0xde, 0x2f}, // mix   : 9
{0xe0, 0x0d, 0x40, 0x25, 0xff, 0x2c, 0xb1, 0xbb, 0xcb, 0xd6, 0x22, 0x96, 0x88, 0x8c, 0x70, 0x05}, // rk    : 10
{0x64, 0xa4, 0xe6, 0xc5, 0x6f, 0xf3, 0x7f, 0xbd, 0x5e, 0x68, 0x8c, 0xcc, 0x40, 0x9c, 0xae, 0x2a}, // addkey: 10
{0x43, 0x49, 0x8e, 0xa6, 0xa8, 0x0d, 0xd2, 0x7a, 0x58, 0x45, 0x64, 0x4b, 0x09, 0xde, 0xe4, 0xe5}, // sub   : 10
{0x43, 0x0d, 0x64, 0xe5, 0xa8, 0x45, 0xe4, 0xa6, 0x58, 0xde, 0x8e, 0x7a, 0x09, 0x49, 0xd2, 0x4b}, // shift : 10
{0xb2, 0x5c, 0x2b, 0xe1, 0x4d, 0x70, 0x9a, 0x5a, 0x86, 0xa6, 0xb8, 0xcc, 0x0e, 0x2a, 0xc8, 0xc9}}; // rk    : 11
//{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00}, // all 0
//{0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff}}; // all 1
	uint8_t aes_correct[AES_BYTES] = {0xf1, 0x51, 0x4f, 0x04, 0xe5, 0x35, 0x7e, 0xfc, 0xde, 0x78, 0x36, 0xb6, 0x07, 0x63, 0x1a, 0x82}; // addkey: 11*/


unsigned int clock_counter = 0;
uint8_t test_status[MACHINES] = {0};
uint8_t prev_status[MACHINES] = {0};
int verbose = 0;
bool logpid = true;

typedef uint8_t glitchbuf[MACHINES][bytes_in(glitches)];

void log_verbose(int level, const char* fmt, ...) {
	if (verbose >= level) {
		if (logpid)
			printf("[%d] ", getpid());
		va_list args;
		va_start(args, fmt);
		vprintf(fmt, args);
		va_end(args);
	}
}

int connect(char *address) {
	struct sockaddr_un addr;
	int fd;

	fd = socket(AF_UNIX, SOCK_STREAM, 0);
	assertf(fd >= 0, "Unable to connect to %s", address);

	memset(&addr, 0, sizeof(addr));
	addr.sun_family = AF_UNIX;
	strncpy(addr.sun_path, address, sizeof(addr.sun_path) - 1);

	int res = connect(fd, (struct sockaddr*)&addr, sizeof(addr));
	assertf(res >= 0, "Unable to connect to pipe");

	return fd;
}

Votaes *freshcore() {
	Votaes *top = new Votaes;

	// reset
	int clk_i = 0;
	set_clk_i_all(top, clk_i);
	set_rst_ni_all(top, 0);
	for(int i = 0; i < 10; i++) {
		top->eval();
		clk_i = !clk_i;
		set_clk_i_all(top, clk_i);
	}
	set_rst_ni_all(top, 1);

	top->eval();
	clk_i = !clk_i;
	set_clk_i_all(top, clk_i);

	uint8_t aes_output_state[AES_BYTES];
	for (int i = 0; i < AES_BYTES; i++)
		aes_output_state[i] = ~aes_key[i]; // Just take the inverse of the key as input to avoid false positives in detecting leaked states

	for (int vm = 0; vm < MACHINES; vm++) {
		set_aes_input_buf(top, vm, &aes_states[0]);
		set_aes_key_buf(top, vm, &aes_key[0]);
		set_aes_output_buf(top, vm, aes_output_state);
	}

   	return top;
}

void injectfaults(Votaes *top, glitchbuf glitches) {
	// XXX the order of bits needs to be checked
	log_verbose(2, "Inserting glitches at cycle %d\n", clock_counter);
	for (int vm = 0; vm < MACHINES; vm++) {
		set_glitches_buf(top, vm, &(glitches[vm][0]));
		if (verbose > 3) {
			int total = 0;
			for (int glitch = 0; glitch < bytes_in(glitches); glitch++) 
				total += __builtin_popcount(glitches[vm][glitch]);

			log_verbose(4, "Glitches for vm %d = %d, pins: ", vm, total);
			loop_glitches(top, vm, print_if_bit_1, NULL);
			printf("\n"); // B/c log_verbose doesn't
		}
	}
}

void runcore(Votaes *top, char* tracefile, uint32_t machines, uint32_t clocks, uint32_t start, uint32_t width, glitchbuf glitches) {
	// Disable not used machines
	for (int i = machines; i < MACHINES; i++) {
		test_status[i] = TEST_NO_FAULT;
	}
	/*for (int vm = 0; vm < MACHINES; vm++) {
		uint8_t aes_output[16] = {0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff};
		get_aes_output_buf(top, vm, &aes_output[0]);
		log_verbose(2, "VM %d info before: 0x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\n", vm, aes_output[0], aes_output[1], aes_output[2], aes_output[3], aes_output[4], aes_output[5], aes_output[6], aes_output[7], aes_output[8], aes_output[9], aes_output[10], aes_output[11], aes_output[12], aes_output[13], aes_output[14], aes_output[15]);
	}*/

	// Open trace file
	VerilatedVcdC* tfp = NULL;
	if (tracefile != NULL) {
		assertf(machines == 1, "Cannot trace more than one machine (machines specified: %d)", machines);
		// We currently only trace 1 machine because we only have once VCD file as output :)
		Verilated::traceEverOn(true);
		tfp = new VerilatedVcdC();
		top->trace(tfp, 99); // Trace 99 levels of hierarchy
		tfp->open(tracefile);
	}

	// tick for a finite number of cycles
	int clk_i = get_clk_i(top, 0);
	int num_done = 0;
	int i;
	for(i = 0; (i < clocks * 2) && (num_done < machines); i++) {
		log_verbose(4, "clock %d\n", clock_counter);

		// Inject faults
		if(clk_i) {
			clock_counter++;

			if (width > 0) {
				if(clock_counter == start) {
					injectfaults(top, glitches);
				} else if(clock_counter == start + width) {
					set_glitches_zero(top);
				}
			}
		}

		// Evaluate clock cycle
		top->eval();
		clk_i = !clk_i;
		set_clk_i_all(top, clk_i);

		// Check test is done
		num_done = 0;
		for (int vm = 0; vm < machines; vm++)
		    if (get_test_done_o(top, vm))
		        num_done++;

		// Dump if we need to
		if (tfp != NULL)
		    tfp->dump(i);
	}  
	/*for (int vm = 0; vm < MACHINES; vm++) {
		uint8_t aes_output[16] = {0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff};
		get_aes_output_buf(top, vm, &aes_output[0]);
		log_verbose(2, "VM %d info after : 0x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\n", vm, aes_output[0], aes_output[1], aes_output[2], aes_output[3], aes_output[4], aes_output[5], aes_output[6], aes_output[7], aes_output[8], aes_output[9], aes_output[10], aes_output[11], aes_output[12], aes_output[13], aes_output[14], aes_output[15]);
	}*/

	log_verbose(2, "Test done after %d cycles\n", i/2);

	if (tfp != NULL)
		tfp->close();
	
	for (int vm = 0; vm < machines; vm++) {
		if (!get_test_done_o(top, vm)) {
		    test_status[vm] = TEST_UNEXPLOITABLE;
		    log_verbose(1, "VM %d didn't complete AES\n", vm);
		    continue;
		} else {
		    log_verbose(2, "VM %d completed AES\n", vm);
		}
		uint8_t aes_output[16];
		get_aes_output_buf(top, vm, &aes_output[0]);
		test_status[vm] = TEST_NO_FAULT;

		int numstates = sizeof(aes_states) / sizeof(aes_states[0]);
		//printf("%d states of %d bytes\n", numstates, AES_BYTES);

		int hitstate = -1;
		int hithd = HD_CUTOFF; 
		for (int state = 0; state < numstates; state++) {
		        int hd = 0;
		        for (int byte = 0; byte < AES_BYTES; byte++) {
		                int myhd = __builtin_popcount(aes_states[state][byte] ^ aes_output[byte]);
		                //printf("Byte 0x%02x ^ 0x%02x, hd = %d\n", aes_states[state][byte], aes_output[byte], myhd);
		                hd += myhd;
		        }
		        //printf("State %d has HD of %d\n", state, hd);

		        if (hd < hithd) {
		                //printf("Interesting HD\n");
		                hitstate = state;
		                hithd = hd;
		        }
		}

		// Found an interesting state with low HW
		if (hitstate >= 0) {
		    test_status[vm] = TEST_EXPLOITABLE;
		    log_verbose(1, "VM %d exploitable fault in state %d with hd %d: 0x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\n", vm, hitstate, hithd, aes_output[0], aes_output[1], aes_output[2], aes_output[3], aes_output[4], aes_output[5], aes_output[6], aes_output[7], aes_output[8], aes_output[9], aes_output[10], aes_output[11], aes_output[12], aes_output[13], aes_output[14], aes_output[15]);
		} else {
		    if (memcmp(aes_correct, aes_output, AES_BYTES) != 0) {
		        test_status[vm] = TEST_UNEXPLOITABLE;
		        log_verbose(1, "VM %d nonexploitable fault: 0x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\n", vm, aes_output[0], aes_output[1], aes_output[2], aes_output[3], aes_output[4], aes_output[5], aes_output[6], aes_output[7], aes_output[8], aes_output[9], aes_output[10], aes_output[11], aes_output[12], aes_output[13], aes_output[14], aes_output[15]);
		    } else {
		        log_verbose(2, "VM %d no fault: 0x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\n", vm, aes_output[0], aes_output[1], aes_output[2], aes_output[3], aes_output[4], aes_output[5], aes_output[6], aes_output[7], aes_output[8], aes_output[9], aes_output[10], aes_output[11], aes_output[12], aes_output[13], aes_output[14], aes_output[15]);
		    }
		}
	}

	delete top;
}

void recvwait(int cli, void* buffer, size_t size) {
	char *buf = (char*)buffer;
	while (size > 0) {
		ssize_t num = read(cli, buf, size);
		assertf(num > 0, "%d unexpected disconnect", cli);

		buf += num;
		size -= num;
	}
}

void receivebuf(int cli, uint8_t id, void* buffer, size_t size) {
	log_verbose(3, "Waiting for %ld bytes from %d, expecting id %02x\n", size, cli, id);
	uint8_t recv_id;
	uint32_t recv_size;

	recvwait(cli, &recv_id, sizeof(recv_id));
	assertf(id == recv_id, "Received wrong ID, is %02x, should be %02x; cli=%d", recv_id, id, cli);

	recvwait(cli, &recv_size, sizeof(recv_size));
	assertf(size == recv_size, "Received wrong number of bytes, is %d, should be %zu; cli=%d, msg_id=%02x", recv_size, size, cli, id);

	recvwait(cli, buffer, size);
	log_verbose(3, "Done receiving bytes from %d\n", cli);
}

void sendbuf(int cli, uint8_t id, void* buffer, size_t size) {
	log_verbose(3, "Sending %ld bytes to %d, with id %02x\n", size, cli, id);

	ssize_t bytes = write(cli, &id, sizeof(id));
	assertf(bytes == sizeof(id), "Unexpected number of bytes written. %zd should be %lu", bytes, sizeof(id));

	bytes = write(cli, &size, 4); // XXX implicit truncate, but should never send this much data
	assertf(bytes == 4, "Unexpected number of bytes written. %zd should be %d", bytes, 4);

	bytes = write(cli, buffer, size);
	assertf(bytes == size, "Unexpected number of bytes written. %zd should be %zu", bytes, size);

	log_verbose(3, "Done %ld bytes to %d\n", size, cli);
}

void send_results(int cli) {
	log_verbose(2, "Client sending results to parent\n");

	sendbuf(cli, MSG_TEST_STATUS, test_status, sizeof(test_status));

	log_verbose(2, "Done sending results to parent\n");
}

void results_to_parent(int child, int parent) {
	log_verbose(2, "Sending results to orchestrator\n");

	uint8_t tmpbuf[MACHINES];
	// test_status
	receivebuf(child, MSG_TEST_STATUS, tmpbuf, sizeof(tmpbuf));
	sendbuf(parent, MSG_TEST_STATUS, tmpbuf, sizeof(tmpbuf));

	log_verbose(2, "Done sending results to orchestrator\n");
}

uint32_t do_glitch(Votaes *top, char* tracefile, int fcmd, int fout, int clocks, uint32_t machines) {
	uint32_t status;
	
	// Allocate glitches buffer
	glitchbuf glitches = {0};
	assertf(sizeof(glitches[0])*MACHINES == sizeof(glitches), "glitchbuf somehow not packed...") // Just double-check it's packed

	// receive arguments
	struct {
		uint32_t clocks;
		uint32_t start;
		uint32_t width;
	} __attribute__((packed)) arguments;
	if (clocks < 0) {
		receivebuf(fcmd, MSG_ARGS, &arguments, sizeof(arguments));

		// TODO: make this a shared memory region
		// receive glitches
		receivebuf(fcmd, MSG_GLITCHBUF, glitches, machines * sizeof(glitches[0]));
	} else {
		arguments.clocks = clocks;
		arguments.start = 0;
		arguments.width = 0;
	}

	// Create pipe for child comms
	int pipe_fds[2];
	pipe2(pipe_fds, O_CLOEXEC); // Close on exit, so we can detect a child when it closes and we're stuck on a recv()

	// We fork here, so the parent stays in the 'just initialized' state.
	// Jasper did an experiment removing fork() and just recalculating state; about the same speed. Leaving fork() in so later we can use it to do multiple faults in a row from one process
	int fd = fork();
	if(fd == 0) {
		close(pipe_fds[0]);
		// child process
		// TODO: redirect stdio/stderr to somewhere
		log_verbose(1, "glitch | machines: %i clocks: %i start: %i width: %i\n", machines, arguments.clocks, arguments.start, arguments.width);
		runcore(top, tracefile, machines, arguments.clocks, arguments.start, arguments.width, glitches);
		send_results(pipe_fds[1]);

		exit(0);
	}
		log_verbose(1, "Spawned child %d\n", fd);

	close(pipe_fds[1]);

	// Read results from child
	results_to_parent(pipe_fds[0], fout);

	// wait for child to exit
	wait((int *)&status);

	return status;
}


int main(int argc, char **argv, char **env) {
	Verilated::commandArgs(argc, argv);

	verbose = 0;
	char *address = NULL;
	char *infile = NULL;
	char *tracefile = NULL;
	uint32_t machines = MACHINES;
	int c;
	bool nofault = false;
	int clocks = -1;
	while ((c = getopt(argc, argv, "n:vs:m:f:c:t:")) != -1) {
		log_verbose(4, "Argument: %c -> %s\n", c, optarg);
		switch (c) {
			case 's':
				machines = atoi(optarg);
				break;
			case 'v':
				verbose++;
				break;
			case 'f':
				infile = optarg;
				break;
			case 'c':
				address = optarg;
				break;
			case 'n':
				clocks = atoi(optarg);
				break;
			case 't':
				tracefile = optarg;
				break;
			default:
				assertf(false, "Unknown command line option %c", c);
		}
	}
	
	// Check arguments
	if (clocks >= 0)
		assertf(infile == NULL && address == NULL, "Must specify only one of address, infile or clocks");
	if (infile != NULL)
		assertf(clocks < 0 && address == NULL, "Must specify only one of address, infile or clocks");
	if (address != NULL)
		assertf(infile == NULL && clocks < 0, "Must specify only one of address, infile or clocks");
	assertf(!(tracefile != NULL && address != NULL), "Cannot trace when using socket address mode");
	assertf(machines <= MACHINES, "Cannot simulate more than machines (%d <= %d)", machines, MACHINES);

	// Create fresh core
	Votaes *top = freshcore();
	int fcmd, fout;
	if (address) {
		// connect to server
		log_verbose(1, "Connecting to %s\n", address);
		fcmd = connect(address);
		fout = fcmd;
	} else if (infile) {
		log_verbose(1, "Reading from %s\n", infile);
		fcmd = open(infile, O_RDONLY);
		fout = open("/dev/null", O_WRONLY); // We don't care about output when reading from file
		logpid = false;
	} else { // clocks
		fcmd = open("/dev/zero", O_RDONLY); // don't care
		fout = open("/dev/null", O_WRONLY); // don't care
		logpid = false;
		uint32_t status = do_glitch(top, tracefile, fcmd, fout, clocks, machines);
		return status; // We're done
	}
	assertf(fcmd >= 0, "Can't open command input");
	assertf(fout >= 0, "Can't open output");


	log_verbose(1, "Sending serving ping\n");

	// tell server our pid as a ping
	uint32_t pid = getpid();
	sendbuf(fout, MSG_PID, &pid, sizeof(pid));

	// Send number of machines
	sendbuf(fout, MSG_NUM_MACHINES, &machines, sizeof(machines));

	while(1) {
		uint32_t status = 0xFFFFFFFF;

		// wait for command
		unsigned int cmd = 0;
		receivebuf(fcmd, MSG_CMD, &cmd, sizeof(cmd));

		if(cmd == COMMAND_VERSION) {
			status = 1337;
		} else if(cmd == COMMAND_GLITCH) {
			status = do_glitch(top, tracefile, fcmd, fout, clocks, machines);
		} else if(cmd == COMMAND_EXIT) {
			break;
		}

		sendbuf(fout, MSG_STATUS, &status, sizeof(status));
	}

	close(fout);
	close(fcmd);

	exit(0);
}
